Attribute VB_Name = "APIStuff"
Option Explicit

Public OldWindowProc As Long

Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Const GWL_WNDPROC = (-4)
Public Const WM_USER = &H400
' Look for WM_SHOWWINDOW.
Public Function NewWindowProc(ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Const WM_NCDESTROY = &H82
Const SW_OTHERUNZOOM = 4
Const SW_OTHERZOOM = 2
Const SW_PARENTCLOSING = 1
Const SW_PARENTOPENING = 3
Const WM_SHOWWINDOW = &H18

Dim reason As String

    ' If we're being destroyed,
    ' restore the original WindowProc.
    If msg = WM_NCDESTROY Then
        SetWindowLong _
            hwnd, GWL_WNDPROC, _
            OldWindowProc
    End If

    If msg = WM_SHOWWINDOW Then
        ' See why the visibility is changing.
        Select Case lParam
            Case SW_OTHERZOOM
                reason = "SW_OTHERZOOM"
            Case SW_PARENTCLOSING
                reason = "SW_PARENTCLOSING"
            Case SW_PARENTOPENING
                reason = "SW_PARENTOPENING"
            Case WM_SHOWWINDOW
                reason = "WM_SHOWWINDOW"
            Case Else
                reason = "<unknown>"
        End Select

        Form1.VisibleEvent CBool(wParam), reason
    End If

    NewWindowProc = CallWindowProc( _
        OldWindowProc, hwnd, msg, wParam, _
        lParam)
End Function
